from s1_models import *
from sqlalchemy import select

# 一般查询
s1 = select([cookies]).where(cookies.c.cookie_name == 'chocolate chip')
rp1 = connection.execute(s1)
record1 = rp1.first()
print(record1.items())

# Like查询
s2 = select([cookies]).where(cookies.c.cookie_name.like('%chocolate%'))
rp2 = connection.execute(s2)
record2 = rp2.fetchall()
for r in record2:
    print(r.cookie_name)

# ClauseElement
# between(cleft, cright) 查找在 cleft 和 cright 之间的列
# concat(column_two) 连接列
# distinct() 查找列的唯一值
# in_([list]) 查找列在列表中的位置
# is_(None) 查找列 None 的位置（通常用于检查 Null 和 None）
# contains(string) 查找包含 string 的列（区分大小写）
# endswith(string) 查找以 string 结尾的列（区分大小写）
# like(string) 查找与 string 匹配的列（区分大小写）
# startswith(string) 查找以 string 开头的列（区分大小写）
# ilike(string) 查找与 string 匹配的列（不区分大小写）

# between
# s3 = select([cookies]).where(cookies.c.quantity.between(10, 99))  # between
# s3 = select([cookies.c.cookie_name.concat(cookies.c.cookie_sku)])  # concat
# s3 = select([cookies.c.cookie_name.distinct()])  # distinct
# s3 = select([cookies]).where(cookies.c.cookie_sku.in_(['CC01', 'CC02']))  # in_
# s3 = select([cookies.c.cookie_id]).where(cookies.c.cookie_recipe_url.is_(None))  # is_(None)
# s3 = select([cookies]).where(cookies.c.cookie_sku.contains('01'))  # contains
# s3 = select([cookies]).where(cookies.c.cookie_name.endswith('chip'))  # endswith
# s3 = select([cookies]).where(cookies.c.cookie_sku.startswith('CC'))  # startswith
s3 = select([cookies]).where(cookies.c.cookie_sku.ilike('%cc%'))  # ilike
rp3 = connection.execute(s3)
record3 = rp3.fetchall()
for r in record3:
    print(r)

#
# # 运算符
# s4 = select([cookies.c.cookie_name, 'sku-' + cookies.c.cookie_sku])
# rp4 = connection.execute(s4)
# for r in rp4.fetchall():
#     print(r)
#
# # Cast
# from sqlalchemy import cast
#
# s5 = select([cookies.c.cookie_name, cast((cookies.c.quantity * cookies.c.unit_cost), Numeric(12, 2)).label('cost')])
# rp5 = connection.execute(s5)
# for r in rp5.fetchall():
#     print(r.cost)
#
# # or and not
# from sqlalchemy import and_, or_, not_
#
# s6 = select([cookies]).where(and_(cookies.c.quantity > 10, cookies.c.unit_cost < 0.40))
# for r in connection.execute(s6):
#     print(r)
#
# s7 = select([cookies]).where(or_(cookies.c.quantity.between(10, 99), cookies.c.cookie_name.contains('chip')))
# rp7 = connection.execute(s7)
# for r in rp7.fetchall():
#     print(r)
